defmodule ExMP4 do
  @moduledoc File.read!("README.md")

  @type timescale :: Ratio.t() | integer()
  @type offset :: integer()
  @type duration :: non_neg_integer()

  @base_date ~U(1904-01-01 00:00:00Z)

  def base_date(), do: @base_date

  def test() do
    # reader = ExMP4.Reader.new!("/home/ghilas/Downloads/Video/Love Like the Galaxy Part 2 Episode 1.mp4")
    # reader = ExMP4.Reader.new!("/tmp/test.mp4")
    reader = ExMP4.Reader.new!("/home/ghilas/Downloads/(HDR HEVC 10-bit BT.2020 24fps) Exodus Sample.mp4")

    tracks = ExMP4.Reader.tracks(reader) |> Enum.sort_by(& &1.id)

    writer =
      ExMP4.Writer.new!("test.mp4")
      |> ExMP4.Writer.write_header()
      |> ExMP4.Writer.add_tracks(tracks)

    writer =
      ExMP4.Reader.stream(reader)
      # |> Stream.take(8)
      |> ExMP4.Reader.samples(reader)
      |> Enum.into(writer)

    ExMP4.Writer.write_trailer(writer)
  end
end
